//Google Rower by Jeff Stewart (jeffball55)
//Google Rower combines google searches so you don't have to continually OR them together
//Also It can search an ip range using the site operator
//This software is free and open source, the only thing asked is if you reuse the code you give
//credit where credit is due.

//Credit goes to Ren Nyffenegger for creating the socket class which this application uses to access google

//Last update July 24, 2000
//Bug reports, suggestions, comments, and questions can be sent to me at jeffball55@hotmail.com or posted to
//the coders section of http://www.johnny.ihackstuff.com

#include "Socket.h"

#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <windows.h>   // needed for get tick count function to
// seed the random generator


using namespace std;

int main(int argc, char *argv[] ) {

	const char quotez = 34;  //used to represent a " in the help message

	if(argc < 3 || strcmp(argv[1],"/h") == 0 || strcmp(argv[1],"help") == 0 || strcmp(argv[1],"/?") == 0)
	{ //print a nice little help message
		cout << "\nUsage for GoogleRower: \n"
			 << " GoogleRower -s Start_Ip_address -e End_Ip_Address [flags] \n"
			 << "   Searches google for an Ip block using the site operator \n"
			 << "   Avaliable flags:\n"
			 << "    -h hex encode the ip addresses \n"
			 << "    -t Specify a Wait Time in milliseconds\n"
			 << "    -r Randomize the searches \n"
			 << "    -c Group ips into blocks of 32 using ORS(|)\n"
			 << "    -f add '&filter=0' to the end of the url \n"
			 << "    -o filename    The name of the output file \n"
			 << "    -p Print the titles instead of the links in \n"
			 << "         the output page\n"
			 << " GoogleRower -g GoogleSearch [flags] \n"
			 << "   Avaliable flags:\n" 
			 << "    -a Brute force to get more results by adding \n"
			 << "         a-z to each search \n"
			 << "    -n Brute force to get more results by adding \n"
			 << "         0-9 to each search \n"
			 << "    -na Brute force to get more results by adding\n"
			 << "         a-z and 0-9 \n"
			 << "    -t Specify a Wait Time between searches \n"
			 << "    -f add '&filter=0' to the end of the url \n"
			 << "    -o filename    The name of the output file \n"
			 << "    -p Print the titles instead of the links in \n"
			 << "         the output page\n"
			 << " Notes:  Include your entire google query in quotes\n"
			 << "   Substitute ' for " << quotez << " in your google query\n"
			 << " Examples:  GoogleRower -g " << quotez <<"'Jeff Stewart' is cool" << quotez << " -t 1000\n"
			 << "   Searches:  " << quotez << "Jeff Stewart" << quotez << " is cool \n"
			 << "    and waits 1 second between searches \n"
			 << "  GoogleRower -s 192.168.1.100 -e 192.168.1.250 -r \n"
			 << "   Searches site:192.168.1.100, site:192.168.1.107 \n"
			 << "    site:192.168.1.172 ... site:192.168.250\n";

		return 0;
	}

	srand(GetTickCount()); 	

	int time = 0; //used to delay the search

    SocketClient s("www.google.com", 80);

	string outfile = "GoogleRowerResults.html";

	bool randomnize = false;
	bool hexencode = false;
	bool filteron = false;
	bool donealready[310] = {false}; //used to make sure there are no duplicates of ip addresses when searching randomly
	bool groupips = false;
	bool usetitles = false;

	for(int i = 1; i < argc; i++)
	{
		if(strcmp(argv[i],"-t") == 0) //delay the search (I never used it but added it any way)
			time = atoi(argv[i+1]);
		else if(strcmp(argv[i],"-h") == 0) //hex encode it
			hexencode = true;
		else if(strcmp(argv[i],"-r") == 0) //randomly search it (Very useful in my opinion)
			randomnize = true;
		else if(strcmp(argv[i],"-f") == 0) //get all results
			filteron = true;
		else if(strcmp(argv[i],"-c") == 0) //group the ip addresses together
			groupips = true;
		else if(strcmp(argv[i],"-o") == 0) //specify an output for the searches
			outfile = argv[i+1];		   //useful for scripting so you don't overwrite previous output
		else if(strcmp(argv[i],"-p") == 0) //print the titles in the html file instead of the links
			usetitles = true;
	}
	
	ofstream	htmlfile(outfile.c_str());// open the output file
	htmlfile << "<ol>"; //start the order list in the output file
	
	if(strcmp(argv[1],"-s") == 0)  // in ip addresses search mode
	{
		string startip = argv[2];
		string endip;
		string getlines = "GET /search?q=site%3A";
		int sip[4]; //start ip address
		int eip[4]; //end ip address
		int cip[4]; //current ip address

		int numreps, pos = 0, oldpos;
		int pagenum = 0;//used to keep track of the results number
		char buffer[150];
		char buffer2[150];
		string allresults = "";//holds all result links gotten so far
		string apage =""; //holds a single html page at a time
		string link = ""; //holds one link at a time
		string title = ""; //holds one title at a time
		bool addedtitle = false;
		int ipblock[32] = {300}; //used for sending ORed searches
		int numleft = 0; //the number of searches left
		bool finished = false; //done yet?
		int highestip = 0; //highest ip address sent out in one search

		if(argc < 5)
		{ // only searching one result
			numreps = 0;
			endip = "None";
			for(int i = 0; i < 4; i++)
			{
				sip[i] = 0;
				while(pos < startip.length() && startip[pos] != '.')
				{
					if(i < 3)
					{
						if(startip[pos+1] == '.')
							sip[i] += (startip[pos]-48);
						else if(startip[pos+2] == '.')
							sip[i] += (startip[pos]-48)*10;
						else
							sip[i] += (startip[pos]-48)*100;
					}
					else
					{
						if(pos == startip.length()-2)
							sip[i] += (startip[pos]-48)*10;
						else if(pos == startip.length()-3)
							sip[i] += (startip[pos]-48)*100;
						else
							sip[i] += (startip[pos]-48);
					}
					pos++;
				}
				cip[i] = sip[i];
				pos++;
			}
		}
		else
		{ //prepare the ip addresses
			endip = argv[4];
			pos = 0;
			for(int i = 0; i < 4; i++)
			{
				eip[i] = 0;
				while(pos < endip.length() && endip[pos] != '.')
				{
					if(i < 3)
					{
						if(endip[pos+1] == '.')
							eip[i] += (endip[pos]-48);
						else if(endip[pos+2] == '.')
							eip[i] += (endip[pos]-48)*10;
						else
							eip[i] += (endip[pos]-48)*100;
					}
					else
					{
						if(pos == endip.length()-2)
							eip[i] += (endip[pos]-48)*10;
						else if(pos == endip.length()-3)
							eip[i] += (endip[pos]-48)*100;
						else
							eip[i] += (endip[pos]-48);
					}
					pos++;
				}
				pos++;
			}
			pos = 0;
			for(i = 0; i < 4; i++)
			{
				sip[i] = 0;
				while(pos < startip.length() && startip[pos] != '.')
				{
					if(i < 3)
					{
						if(startip[pos+1] == '.')
							sip[i] += (startip[pos]-48);
						else if(startip[pos+2] == '.')
							sip[i] += (startip[pos]-48)*10;
						else
							sip[i] += (startip[pos]-48)*100;
					}
					else
					{
						if(pos == startip.length()-2)
							sip[i] += (startip[pos]-48)*10;
						else if(pos == startip.length()-3)
							sip[i] += (startip[pos]-48)*100;
						else
							sip[i] += (startip[pos]-48);
					}
					pos++;
				}
				cip[i] = sip[i];
				pos++;
			}  //end this part with the ip address sections sip, eip, and cip
			
			if(eip[0] != sip[0] || eip[1] != sip[1] || eip[2] != sip[2])
			{
				cout << "\nToo large range, exiting\n";
				return 0;
			}
			if(eip[3] == sip[3])
			{
				numreps = 0;
				endip = "None";
			}
			else
			{
				numreps = eip[3] - sip[3];
				if(numreps < 0)
				{
					cout << "Ip addresses in wrong order.\n";
					return 0;
				}
			}

		}
			
		if(endip != "None") //print a title to the html page
			htmlfile << "<title>" << startip << " - " << endip << " - GoogleRower Search</title>\n";
		else
			htmlfile << "<title>" << startip << " - GoogleRower Search</title>\n";

		if(!((groupips && randomnize) || (groupips && hexencode)))
			cout << "Sending Search for:\n";

		numleft = numreps+1;

		if(groupips)
		{
			if(randomnize)
			{  //set up the first ip addresses to be searched randomly
				for(int k = 0; k < 32 && numleft > 1  ; k++)
				{
					while(donealready[ipblock[k]] || ipblock[k] > eip[3] || ipblock[k] < sip[3])
					{
						ipblock[k] = rand()%(eip[3]-sip[3]) + sip[3] + 1 ;
					}
					numleft--;
					donealready[ipblock[k]]=true;
					//cout << ipblock[k] << "\n"; //uncomment to see the order of the search
				}
			}
			else
			{
				cip[3]--;
				for(int k = 0; k < 32; k++)
				{
					numleft--;
					cip[3]++; //set up the first ip addresses to be searched by incrementing
					ipblock[k] = cip[3];
					if(numleft < 0)
						ipblock[k] = 300;
				}
			}
		}
		for(int i = 0; i <= numreps; i++)
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		{//start the ip loop ///////////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			while(pagenum == 0 || (apage.find("In order to show you the most relevant results, we have omitted some entries very similar to the",0) == string::npos && apage.find("<TITLE>302 Moved</TITLE>",0) == string::npos && apage.find("Result&nbsp;Page:&nbsp;</font>",0) != string::npos))
			{
				if(finished)
				{ //if fininished getting results then exit the while and set the counter to exit on the next for loop
					i = numreps + 1;
					break;
				}
				apage = "";			
				sprintf(buffer, "%d", pagenum);
				pagenum+=100; //get the next results
				if(pagenum > 1000)
					goto bottom3; //if we have gotten 1000 results go to a new search

				if(!hexencode && !groupips)
				{ // put the ip addresses in buffer2
					sprintf(buffer2,"%d.%d.%d.%d",cip[0],cip[1],cip[2],cip[3]);
					cout << cip[0] << "." << cip[1] << "." << cip[2] << "." << cip[3] << "\n";
				}
				else if(!groupips)
				{ //hex encode it
					sprintf(buffer2,"");
					char buffer3[10];
					char buffer4[10];
					for(int k = 0; k < 4; k++)
					{
						sprintf(buffer3,"%d",cip[k]);
						for(int j = 0; j < 3 && buffer3[j] != NULL; j++)
						{			
							sprintf(buffer4,"%x",buffer3[j]);
							strcat(buffer2,"%");
							strcat(buffer2,buffer4);
						}
						if(k != 3)
							strcat(buffer2,"%2e"); //add a period
					}
					cout << cip[0] << "." << cip[1] << "." << cip[2] << "." << cip[3] << " = " << buffer2 << "\n";
				}

				if(filteron  && !groupips) //add the ends to the get request
					getlines = getlines + buffer2 + "&num=100&start=" + buffer + "&filter=0 HTTP/1.1";
				else if(!groupips)
					getlines = getlines + buffer2 + "&num=100&start=" + buffer + " HTTP/1.1";
				else
				{//group the ips together using |s
					if(!hexencode)
					{ //add the ipaddresses to the get request without hex encoding
						sprintf(buffer2,"%d.%d.%d.%d",cip[0],cip[1],cip[2],ipblock[0]);
					//	cout<< buffer2 << "\n"; //uncomment to print each ip
						getlines = getlines + buffer2;
						highestip = 0;
						for(int k = 1; k < 32; k++)
						{
							if(ipblock[k] != 300)
							{
								highestip = k;
								sprintf(buffer2,"%d.%d.%d.%d",cip[0],cip[1],cip[2],ipblock[k]);
								//cout << buffer2 << "\n";   //uncomment to print each ip
								getlines = getlines + "+%7C+site%3A" + buffer2;
							}
						}
						getlines = getlines + "&num=100&start=" + buffer;
						
						if(filteron)
							getlines = getlines + "&filter=0 HTTP/1.1";
						else
							getlines = getlines + " HTTP/1.1";
						if(highestip != 0 && !randomnize)
							cout << cip[0] << "." << cip[1] << "." << cip[2] << "." << ipblock[0] << "-" << ipblock[highestip] << "\n";
						else if(!randomnize)
							cout << cip[0] << "." << cip[1] << "." << cip[2] << "." << ipblock[0] << "\n";
					}
					else
					{ //group and hex encode the ip addresses
						for(int q = 0; q < 32; q++)
						{
							sprintf(buffer2,"");
							char buffer3[5];
							char buffer4[5];
							for(int k = 0; k < 4; k++)
							{
								if(ipblock[q] != 300)
								{
									if(k != 3)
										sprintf(buffer3,"%d",cip[k]);
									else
										sprintf(buffer3,"%d",ipblock[q]);
	
									for(int j = 0; j < 3 && buffer3[j] != NULL; j++)
									{			
										sprintf(buffer4,"%x",buffer3[j]);
										strcat(buffer2,"%");
										strcat(buffer2,buffer4);
									}
									if(k != 3)
										strcat(buffer2,"%2e"); //add a period
								}
							}//end with the hex of the ip addresses in buffer2
							if(q == 0 && ipblock[q] != 300)
							{ //add the first ip
								getlines = getlines + buffer2;
							}
							else if(ipblock[q] == 0)
							{ //get rid of annoying extra ip addresses that end in 0
								if(ipblock[q] >= sip[3] && ipblock[q] <= eip[3])
								{
									bool usedalready = false;
									for(int p = 0; p < q; p++)
									{
										if(ipblock[p] == 0)
											usedalready = true; //check to see if 0 was searched already
									}
									if(!usedalready)
										getlines = getlines + "+%7C+site%3A" + buffer2;
								}
							}
							else if(ipblock[q] != 300 && ipblock[q] != ipblock[q-1])
							{//add other ip addresses
								getlines = getlines + "+%7C+site%3A" + buffer2;
							}
						}

						getlines = getlines + "&num=100&start=" + buffer;
						if(filteron)
							getlines = getlines + "&filter=0 HTTP/1.1";
						else  // add the end lines to the url search
							getlines = getlines + " HTTP/1.1";
					}
				}

				s.SendLine(getlines);
				s.SendLine("Host: www.google.com/"); //send the get request
				s.SendLine("");
	
				bool cnt = true;

				while (cnt) 
				{//continue to get the page until stopped at the end or the page is forbidden
					string l = s.ReceiveLine();
					if (l.empty())
						goto end2;					

						
					apage +=  l;

					if(l.find("</html>",0) != string::npos) //end of page
						goto end2;
					else if(apage.find("<TITLE>302 Moved</TITLE>",0) != string::npos) //page is now forbidden
						goto bottom2;

				} //ends while that gets the web page
		end2:
				oldpos = 0;
				while(apage.find("href=",oldpos) != string::npos)
				{ //get all the links
					pos = apage.find("href=",oldpos);
					link = apage.substr(pos+6 ,(apage.find('>',pos)-1)-(pos+6));	
					if((link.find("http",0) != string::npos || link.find("ftp",0) != string::npos) && link.find("google.com",0) == string::npos && link.find("/url?",0) == string::npos && link.find("search?q=cache",0) == string::npos && link.find("/iclk?sa",0) == string::npos && link.find("related:",0) == string::npos && link.find("/search?",0) == string::npos && link.find("?sa=X&oi=dict",0) == string::npos && link.find("onmouseover=",0) == string::npos)
					{
						if(allresults.find(link,0) == string::npos)
						{// if found a result
							if(!addedtitle) //if a title and search hasnt been added yet add them now
							{
								if(groupips && !randomnize && !hexencode)
									sprintf(buffer2,"%d.%d.%d.%d-%d",cip[0],cip[1],cip[2],ipblock[0],ipblock[highestip]);
								else if(!groupips)
									sprintf(buffer2,"%d.%d.%d.%d",cip[0],cip[1],cip[2],cip[3]);
								else if(groupips && randomnize)
									sprintf(buffer2,"Random Ip addresses");
								else
									sprintf(buffer2,"");

								htmlfile << "<h3><a href=http://www.google.com" << getlines.substr(4,getlines.length()-12) << ">Site:" << buffer2 << "</a> Starting at result number " << buffer << "</h3>\n";

								addedtitle = true;
							}
							allresults += link + " "; //add the link to the list
							title= apage.substr(apage.find('>',pos)+1,(apage.find("</a>",pos)-apage.find('>',pos))-1);
							if(usetitles)
							{
								htmlfile << "<li><a href=" << link << ">" << title << "</a></li>\n";  
							}
							else
							{
								htmlfile << "<li><a href=" << link << ">" << link << "</a></li>\n";  
							}
							htmlfile.flush();
						}
					}
					oldpos = pos +1;
				}  //end while that gets the links
		bottom2:
				addedtitle = false;
				getlines = "GET /search?q=site%3A"; //set up the loop to get the next 100 results if possible
				Sleep(time);
			} //ends while that keeps hitting next results
	bottom3:
			apage = "";	 //set up the loop for the next search
			pagenum = 0;
			if(!groupips)
			{// if the ips addresses arent being grouped
				donealready[cip[3]]=true;
				if(randomnize && i != numreps)
				{ //get the next ip address to search randomly
					while(donealready[cip[3]] || cip[3] > eip[3] || cip[3] < sip[3])
					{
						cip[3] = rand()%(eip[3]-sip[3]) + sip[3] + 1 ;
					}
				}
				else
					cip[3]++;//get the next ip address to search by incrementing this ip 
			}
			else
			{
				if(randomnize)
				{
					if(numleft <= 1)
						finished = true;
					else
					{  //set up the next grouping of ip addresses to search randomly
						for(int k = 0; k < 32; k++)
						{
							ipblock[k] = 300;
						}
						for(k = 0; k < 32 && numleft > 1; k++)
						{
							while(donealready[ipblock[k]] || ipblock[k] > eip[3] || ipblock[k] < sip[3])
							{
								ipblock[k] = rand()%(eip[3]-sip[3]) + sip[3];
							}
							donealready[ipblock[k]]=true;
							numleft--;
							//cout << ipblock[k] << "\n"; //uncomment to see the order of the search
						}
					}
				}
				else
				{
					if(numleft < 0)
						finished = true;
					for(int k = 0; k < 32; k++)
					{//set up the next grouping of ip addresses to search by incrementing these ip addresses
						numleft--;
						cip[3]++;
						ipblock[k] = cip[3];
						if(numleft < 0)
							ipblock[k] = 300;
					}
				}
			}
		}//ends the for loop that switches queries
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}///////Brute force Google Search Mode////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	else if(strcmp(argv[1],"-g") == 0)
	{
		char brute;  //the character to be added to the google search
		int numreps, pos ,oldpos; 
		int pagenum = 0; //used to hold the number of results
		char buffer[150];
		string allresults = ""; //holds all the result links
		string apage =""; //holds a single html page at once
		string link = ""; //holds a single result link at a time
		string title = ""; //holds a single title at a time
		bool addedtitle = false;

		string getlines = "GET /search?q=";
		string searchstring = argv[2];
		
		for(int i = 0; i < searchstring.length(); i++)
		{
			if(searchstring[i] == 39)  //change ' to %22 which is hex for "
			{
				searchstring[i] = '%';
				searchstring.insert(i+1,"22");
			}
			else if(searchstring[i] == ' ') //change spaces to +'s
			{
				searchstring[i] = '+';
			}

			if(argv[2][i] == 39)
				argv[2][i] = 34;
		}
		
		brute = 48;
		numreps = 0;
		
		for(i = 0; i < argc; i++)
		{
			if(strcmp(argv[i],"-a") == 0) //if brute forcing with letters
			{
				brute = 'a' - 1;
				numreps = 26;
				htmlfile << "<title>" << argv[2] << " a-z - GoogleRower Search</title>\n"; //add an html title to the page
			}
			else if(strcmp(argv[i],"-n") == 0) //if brute forcing with numbers
			{
				brute = '0' - 1;
				numreps = 10;
				htmlfile << "<title>" << argv[2] << " 0-9 - GoogleRower Search</title>\n"; //add an html title to the page
			}
			else if(strcmp(argv[i],"-na") == 0) //if brute forcing with both numbers and letters
			{
				brute = '0' - 1;
				numreps = 36;
				htmlfile << "<title>" << argv[2] << " 0-z - GoogleRower Search</title>\n"; //add an html title to the page
			}
		}
		if(numreps == 0)
			htmlfile << "<title>" << argv[2] << " - GoogleRower Search</title>\n"; //add an html title to the page

		cout << "Sending  Search: \n"; 

		for(i = 0; i <= numreps; i++)
		{
			while(pagenum == 0 || (apage.find("In order to show you the most relevant results, we have omitted some entries very similar to the",0) == string::npos && apage.find("<TITLE>302 Moved</TITLE>",0) == string::npos && apage.find("Result&nbsp;Page:&nbsp;</font>",0) != string::npos))
			{//continue while there are more results
				apage = "";			
				sprintf(buffer, "%d", pagenum);
				pagenum+=100;

				if(pagenum > 1000) //if we have 1000 results go to the next search
					goto bottom4;

				if(numreps != 0 && i != 0) //add the searchstring to the get request
				{
					cout << argv[2] << " " << brute << "   Results starting at " << pagenum-100 << "\n";
					getlines = getlines + searchstring + "+" + brute + "&num=100&start=" + buffer;
				}
				else 
				{
					cout << argv[2] << "   Results starting at " << pagenum-100 << "\n";
					getlines = getlines + searchstring + "&num=100&start=" + buffer;				
				}
				
				if(filteron)	
					getlines = getlines + "&filter=0 HTTP/1.1"; //finish the get request
				else
					getlines = getlines + " HTTP/1.1";


				s.SendLine(getlines);
				s.SendLine("Host: www.google.com/"); //send the get request
				s.SendLine("");

				bool cnt = true;

				while (cnt) 
				{//continue adding data into apage until the end of the page or a 403 error happens
					string l = s.ReceiveLine();
					if (l.empty())
						goto end;					

					
					apage +=  l; 

					if(l.find("</html>",0) != string::npos) //end of page
						goto end;
					else if(apage.find("<TITLE>302 Moved</TITLE>",0) != string::npos) //page is now forbidden
						goto bottom;

				}
		end:
				oldpos = 0;
				while(apage.find("href=",oldpos) != string::npos)
				{ //get all the links
					pos = apage.find("href=",oldpos);
					link = apage.substr(pos+6,(apage.find('>',pos)-1)-(pos+6));	
					if((link.find("http",0) != string::npos || link.find("ftp",0) != string::npos) && link.find("google.com",0) == string::npos && link.find("/url?",0) == string::npos && link.find("search?q=cache",0) == string::npos && link.find("/iclk?sa",0) == string::npos && link.find("related:",0) == string::npos && link.find("/search?",0) == string::npos && link.find("?sa=X&oi=dict",0) == string::npos && link.find("onmouseover=",0) == string::npos)
					{
						if(allresults.find(link,0) == string::npos)
						{
							if(!addedtitle)
							{ //add a header to the html page
								if(numreps != 0 && i != 0)
								{
									htmlfile << "<h3><a href=http://www.google.com" << getlines.substr(4,getlines.length()-12) << ">" << argv[2] << " " << brute << "</a> Starting at number " << buffer << "</h3>\n";
								}
								else
								{
									htmlfile << "<h3><a href=http://www.google.com" << getlines.substr(4,getlines.length()-12) << ">" << argv[2] << "</a> Starting at number " << buffer << "</h3>\n";
								}

								addedtitle = true;
							}
							allresults += link + " ";
							title= apage.substr(apage.find('>',pos)+1,(apage.find("</a>",pos)-apage.find('>',pos))-1);
							if(usetitles)
							{
								htmlfile << "<li><a href=" << link << ">" << title << "</a></li>\n";  
							}
							else
							{
								htmlfile << "<li><a href=" << link << ">" << link << "</a></li>\n";  
							}
						}
					}
					oldpos = pos +1;
				}
		bottom: //get ready for the more results from the next 100 results
				addedtitle = false;
				getlines = "GET /search?q=";
				Sleep(time);
			}
		bottom4: //get ready for another search
			apage = "";	
			pagenum = 0;
			brute = brute+1;  //increment the brute char
			if(brute == ':') //if the brute char has gone past 9 change it to a (when using -na option)
				brute = 'a';
		}
	}
	else
	{//error with the input
		cout << "\n  Usage Error \n  execute GoogleRower with no arguments for help \n";
		return 0;
	}

  htmlfile << "</ol>";//finish the ordered list and close the html page
  htmlfile.close();
  return 0;
}















